package domaine;

import java.util.HashMap;

public class MemoFibo {
	private static MemoFibo uniqueInstance;
	private HashMap<Integer,Long> memo;
	private MemoFibo() {
		memo = new HashMap<Integer,Long>();
	}
	public static MemoFibo getInstance() {
		if (uniqueInstance == null) uniqueInstance = new MemoFibo();
		return uniqueInstance;
	}
	public long fibo(int n) {
		if (memo.containsKey(n)) return memo.get(n);
		long r = Fibo.fibo(n);
		memo.put(n, r);
		return r;
	}
}
